--------------------------------------------------------------------------------
-- SubModule AverageADC
-- Created   4/12/2005 5:51:13 PM
--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

entity AverageADC is port
   (
     I          : in    std_logic_vector(31 downto 0);  -- input
     O          : out   std_logic_vector(31 downto 0);  -- output
     CNT        : in    std_logic_vector( 2 downto 0);  -- count
     CLK        : in    std_logic;                      -- clock
     ADDEN      : in    std_logic                       -- add enable
    );
end AverageADC;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of AverageADC is

   signal term : signed(31 downto 0);
   signal accu : signed(31 downto 0) := (others => '0');

begin
   reg: process (CLK, ADDEN) is
   begin
      if rising_edge (CLK) then
         if ADDEN = '1' then
            term <= signed (I);
         end if;
      end if;
   end process reg;
   -- add all 4 ADC values
   add: process (CLK, ADDEN, CNT) is
   begin
      if rising_edge (CLK) then
         if ADDEN = '1' then
            if CNT = B"001" then
               accu <= signed (term);
            else
               accu <= accu + signed (term);
            end if;
         end if;
      end if;
   end process add;
   -- load new ADC value into register
   O <= std_logic_vector (accu);
end Structure;
--------------------------------------------------------------------------------


















































