--------------------------------------------------------------------------------
-- SubModule DecimationDecod
-- Created   8/29/2006 3:46:43 PM
--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;

entity DecimationDecod is port
   (
     I         : in    std_logic_vector(2 downto 0);
     O         : out   std_logic;
     DEC       : in    std_logic_vector(1 downto 0)
   );
end DecimationDecod;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of DecimationDecod is

-- Component Declarations

-- Signal Declarations

begin
   -- decimation decoding
   decode: process (DEC, I) is
   begin
      if (DEC = B"11") then
         O <= I(2) or I(1) or I(0);
      elsif (DEC = B"10") then
         O <= I(1) or I(0);
      elsif (DEC = B"01") then
         O <= I(0);
      else
         O <= '0';
      end if;
   end process decode;

end Structure;
--------------------------------------------------------------------------------
