--------------------------------------------------------------------------------
-- SubModule IIR_ADC
-- Created   4/12/2005 5:51:13 PM
--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;

entity IIR_DAC is port
   (
     DAC        : out   std_logic_vector(31 downto 0);  -- PCM1704
     I          : in    std_logic_vector(31 downto 0);  -- filter value
     OVF        : out   std_logic   -- overflow
   );
end IIR_DAC;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of IIR_DAC is

   signal ext : std_logic_vector(31 downto 0);

begin
   -- sign extend and shift DAC value
   ext(28 downto 0) <= I(31 downto 3);
   ext(31 downto 29) <= (others => I(31));
   --
   DAC <= ext;

   -- check overflow on registered input
   overflow: process (ext) is
   begin
      if (ext(31 downto 24) = B"00001111") or
         (ext(31 downto 24) = B"11110000") then
         OVF <= '1';
      else
         OVF <= '0';
      end if;
   end process overflow;

end Structure;
