--------------------------------------------------------------------------------
-- SubModule SUM4
-- Created   4/12/2005 5:51:13 PM
--------------------------------------------------------------------------------
Library IEEE;
Use IEEE.Std_Logic_1164.all;
use IEEE.Numeric_Std.all;

entity SUM4 is port
   (
     I1         : in    std_logic_vector(31 downto 0);  -- AD7679
     I2         : in    std_logic_vector(31 downto 0);  -- AD7679
     I3         : in    std_logic_vector(31 downto 0);  -- AD7679
     I4         : in    std_logic_vector(31 downto 0);  -- AD7679
     O          : out   std_logic_vector(31 downto 0);  -- sign extended ADC value
     CLK        : in    std_logic;
     CE         : in    std_logic
    );
end SUM4;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of SUM4 is

   signal sumA : signed(31 downto 0) := (others => '0');
   signal sumB : signed(31 downto 0) := (others => '0');
   signal diff : signed(31 downto 0) := (others => '0');

begin
   -- add all 4 ADC values
   add: process (CLK) is
   begin
      if rising_edge (CLK) then
         sumA <= signed(I1) + signed (I3);
         sumB <= signed(I2) + signed (I4);
      end if;
   end process add;
   diff <= sumA - sumB;
   -- load new ADC value into register
   reg: process (CLK, CE) is
   begin
      if rising_edge (CLK) then
         if CE = '1' then
            O <= std_logic_vector(diff);
         end if;
      end if;
   end process reg;
end Structure;
--------------------------------------------------------------------------------
